### Home Classes Methods

### In Files

- lib/sass/cache_stores/base.rb

### Parent

Object

### Methods

- #_retrieve
- #_store
- #key
- #retrieve
- #store

### Class/Module Index

Quicksearch

- Sass
- Sass::CSS
- Sass::CacheStores
- Sass::CacheStores::Base
- Sass::CacheStores::Chain
- Sass::CacheStores::Filesystem
- Sass::CacheStores::Memory
- Sass::CacheStores::Null
- Sass::Callbacks
- Sass::Callbacks::InstanceMethods
- Sass::Engine
- Sass::Engine::Line
- Sass::Environment
- Sass::Exec
- Sass::Exec::Generic
- Sass::Exec::Sass
- Sass::Exec::SassConvert
- Sass::Exec::Scss
- Sass::Importers
- Sass::Importers::Base
- Sass::Importers::Filesystem
- Sass::Logger
- Sass::Logger::Base
- Sass::Logger::LogLevel
- Sass::Logger::LogLevel::ClassMethods
- Sass::Media
- Sass::Media::Query
- Sass::Media::QueryList
- Sass::Plugin
- Sass::Plugin::Compiler
- Sass::Plugin::Configuration
- Sass::Plugin::MerbBootLoader
- Sass::Plugin::Rack
- Sass::Plugin::StalenessChecker
- Sass::Repl
- Sass::SCSS
- Sass::SCSS::CssParser
- Sass::SCSS::Parser
- Sass::SCSS::RX
- Sass::SCSS::ScriptLexer
- Sass::SCSS::ScriptParser
- Sass::SCSS::StaticParser
- Sass::Script
- Sass::Script::ArgList
- Sass::Script::Bool
- Sass::Script::Color
- Sass::Script::CssLexer
- Sass::Script::CssParser
- Sass::Script::Funcall
- Sass::Script::Functions
- Sass::Script::Functions::EvaluationContext
- Sass::Script::Interpolation
- Sass::Script::Lexer
- Sass::Script::List
- Sass::Script::Literal
- Sass::Script::Node
- Sass::Script::Null
- Sass::Script::Number
- Sass::Script::Operation
- Sass::Script::Parser
- Sass::Script::String
- Sass::Script::StringInterpolation
- Sass::Script::UnaryOperation
- Sass::Script::Variable
- Sass::Selector
- Sass::Selector::AbstractSequence
- Sass::Selector::Attribute
- Sass::Selector::Class
- Sass::Selector::CommaSequence
- Sass::Selector::Element
- Sass::Selector::Id
- Sass::Selector::Interpolation
- Sass::Selector::Parent
- Sass::Selector::Placeholder
- Sass::Selector::Pseudo
- Sass::Selector::SelectorPseudoClass
- Sass::Selector::Sequence
- Sass::Selector::Simple
- Sass::Selector::SimpleSequence
- Sass::Selector::Universal
- Sass::Shared
- Sass::Supports
- Sass::Supports::Condition
- Sass::Supports::Declaration
- Sass::Supports::Interpolation
- Sass::Supports::Negation
- Sass::Supports::Operator
- Sass::SyntaxError
- Sass::Tree
- Sass::Tree::CharsetNode
- Sass::Tree::CommentNode
- Sass::Tree::ContentNode
- Sass::Tree::CssImportNode
- Sass::Tree::DebugNode
- Sass::Tree::DirectiveNode
- Sass::Tree::EachNode
- Sass::Tree::ExtendNode
- Sass::Tree::ForNode
- Sass::Tree::FunctionNode
- Sass::Tree::IfNode
- Sass::Tree::ImportNode
- Sass::Tree::MediaNode
- Sass::Tree::MixinDefNode
- Sass::Tree::MixinNode
- Sass::Tree::Node
- Sass::Tree::PropNode
- Sass::Tree::ReturnNode
- Sass::Tree::RootNode
- Sass::Tree::RuleNode
- Sass::Tree::SupportsNode
- Sass::Tree::TraceNode
- Sass::Tree::VariableNode
- Sass::Tree::Visitors
- Sass::Tree::Visitors::Base
- Sass::Tree::Visitors::CheckNesting
- Sass::Tree::Visitors::Convert
- Sass::Tree::Visitors::Cssize
- Sass::Tree::Visitors::DeepCopy
- Sass::Tree::Visitors::Extend
- Sass::Tree::Visitors::Perform
- Sass::Tree::Visitors::SetOptions
- Sass::Tree::Visitors::ToCss
- Sass::Tree::WarnNode
- Sass::Tree::WhileNode
- Sass::UnitConversionError
- Sass::Util
- Sass::Util::MultibyteStringScanner
- Sass::Util::StaticConditionalContext
- Sass::Util::SubsetMap
- Sass::Util::Test
- Sass::Version
- ActionController
- ActionController::Base
- Object

No matching classes.

# Sass::CacheStores::Base

An abstract base class for backends for the Sass cache. Any key-value store can act as such a backend; it just needs to implement the {#_store} and {#_retrieve} methods.

To use a cache store with Sass, use the {file:SASS_REFERENCE.md#cache_store-option `:cache_store` option}.

@abstract

### Public Instance Methods

_retrieve(key, version, sha) click to toggle source

Retrieved cached contents. Must be implemented by all subclasses.

Note: if the key exists but the sha or version have changed, then the key may be deleted by the cache store, if it wants to do so.

@param key [String] The key to retrieve @param version [String] The current sass version.

    Cached contents must not be retrieved across different versions of sass.

@param sha [String] The sha of the sass source.

    Cached contents must not be retrieved if the sha has changed.

@return [String] The contents that were previously stored. @return [NilClass] when the cache key is not found or the version or sha have changed.

    # File lib/sass/cache_stores/base.rb, line 41
    def _retrieve(key, version, sha)
      raise "#{self.class} must implement #_retrieve."
    end

_store(key, version, sha, contents) click to toggle source

Store cached contents for later retrieval Must be implemented by all CacheStore subclasses

Note: cache contents contain binary data.

@param key [String] The key to store the contents under @param version [String] The current sass version.

    Cached contents must not be retrieved across different versions of sass.

@param sha [String] The sha of the sass source.

    Cached contents must not be retrieved if the sha has changed.

@param contents [String] The contents to store.

    # File lib/sass/cache_stores/base.rb, line 24
    def _store(key, version, sha, contents)
      raise "#{self.class} must implement #_store."
    end

key(sass_dirname, sass_basename) click to toggle source

Return the key for the sass file.

The `(sass_dirname, sass_basename)` pair should uniquely identify the Sass document, but otherwise there are no restrictions on their content.

@param sass_dirname [String]

    The fully-expanded location of the Sass file.
    This corresponds to the directory name on a filesystem.

@param sass_basename [String] The name of the Sass file that is being referenced.

    This corresponds to the basename on a filesystem.

    # File lib/sass/cache_stores/base.rb, line 81
    def key(sass_dirname, sass_basename)
      dir = Digest::SHA1.hexdigest(sass_dirname)
      filename = "#{sass_basename}c"
      "#{dir}/#{filename}"
    end

retrieve(key, sha) click to toggle source

Retrieve a {Sass::Tree::RootNode}.

@param key [String] The key the root element was stored under. @param sha [String] The checksum of the root element's content. @return [Object] The cached object.

    # File lib/sass/cache_stores/base.rb, line 62
    def retrieve(key, sha)
      contents = _retrieve(key, Sass::VERSION, sha)
      Marshal.load(contents) if contents
    rescue EOFError, TypeError, ArgumentError, LoadError => e
      Sass::Util.sass_warn "Warning. Error encountered while reading cache #{path_to(key)}: #{e}"
      nil
    end

store(key, sha, root) click to toggle source

Store a {Sass::Tree::RootNode}.

@param key [String] The key to store it under. @param sha [String] The checksum for the contents that are being stored. @param obj [Object] The object to cache.

    # File lib/sass/cache_stores/base.rb, line 50
    def store(key, sha, root)
      _store(key, Sass::VERSION, sha, Marshal.dump(root))
    rescue TypeError, LoadError => e
      Sass::Util.sass_warn "Warning. Error encountered while saving cache #{path_to(key)}: #{e}"
      nil
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.